#include <IRremote.h>


const int trigPin = 9;
const int echoPin = 10;
const int buzzer = 11;
// defines variables
long duration;
int distance;
int noteLength = 8;
int scale = 2;

IRrecv IR(3);

int tones1[] = {
  57, 76, 96, 116, 138, 162, 187, 213, 241, 255
};

int tones2[] = {
  261, 277, 294, 311, 330, 349, 370, 392, 415, 440
};



void setup() {
  pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
  pinMode(echoPin, INPUT); // Sets the echoPin as an Input
  Serial.begin(9600); // Starts the serial communication

  pinMode(buzzer, OUTPUT);

  IR.enableIRIn();


}


void loop() {
  IR.enableIRIn();
  // Clears the trigPin
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  // Calculating the distance
  distance = duration * 0.034 / 2;


  if (distance < 40) {
    if (scale == 2) {
      tone(buzzer, tones2[distance / 4]);  
    } else {
      tone(buzzer, tones1[distance / 4]);
    }
    
    delay(1000 / noteLength);
  } else {
    noTone(buzzer);
  }

  if (IR.decode()) {
    Serial.println(IR.decodedIRData.decodedRawData, HEX);

    switch(IR.decodedIRData.decodedRawData) {
      case 0xE718FF00: //2
        noteLength = 2;
        break;
      case 0xF708FF00: //4
        noteLength = 4;
        break;
      case 0xAD52FF00: //8
        noteLength = 8;
        break;
      case 0xBF40FF00: // >>
        scale = 2;
        break;
      case 0xBB44FF00: // <<
        scale = 1;
        break;
      default: 
        break;
    }
    IR.resume();
  }

  
}
